/* Problem URL: https://codeforces.com/problemset/problem/963/D */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (size_t i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (size_t i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

struct hashed_string {
    vl hash;
    static vl p;
    static ll b;
    static ll m;

    hashed_string(string &a) {
        hash.resize(a.size() + 1);

        while (p.size() <= a.size()) {
            p.push_back(((__int128)p.back() * b) % m);
        }

        nrep(i, 1, a.size() + 1) {
            hash[i] = ((__int128)hash[i - 1] * b + a[i - 1]) % m;
        }
    }

    ll get_hash(int l, int r) {
        return ((hash[r + 1] - (__int128)hash[l] * p[r - l + 1]) % m + m) % m;
    }
};

vl hashed_string::p = {1};

long long hashed_string::m = (1LL << 61) - 1;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
long long hashed_string::b = uniform_int_distribution<ll>(1, m - 1)(rng);

int inf = INT32_MAX >> 1;

ll get_single_hash(string &a)
{
    ll hash = 0;

    for (auto i : a) {
        hash = ((__int128)hash * hashed_string::b + i) % hashed_string::m;
    }

    return hash;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    string a;
    cin >> a;

    hashed_string hash(a);
    V<bool> sizes(a.size(), false);
    unordered_map<ll, vi> memol;
    unordered_map<ll, vi> memor;

    int n;
    cin >> n;
    while (n--) {
        int k;
        string c;
        cin >> k >> c;

        if (c.size() > a.size()) {
            cout << "-1\n";
            continue;
        }

        ll tmp = get_single_hash(c);

        size_t size = c.size();

        if (!sizes[size - 1]) {
            nrep(i, c.size() - 1, a.size()) {
                ll hashed = hash.get_hash(i - size + 1, i);
                memol[hashed].push_back(i - size + 1);
                memor[hashed].push_back(i);
            }
            sizes[size - 1] = true;
        }

        if (memol[tmp].size() < k) {
            cout << "-1\n";
            continue;
        }

        if (k == 1) {
            cout << size << '\n';
            continue;
        }

        int ans = inf;
        auto &left = memol[tmp];
        auto &right = memor[tmp];

        nrep(i, k - 1, left.size()) {
            rmin(ans, right[i] - left[i - k + 1] + 1);
        }

        cout << ans << '\n';
    }
}
